Require Import Arith.
Require Import Omega.


Lemma minus_plus_commut:
forall m n q, m >= n -> m - n + q = m + q - n.
Proof.
  intros.
  assert (m = n + (m - n)).
  apply le_plus_minus; auto.
  rewrite H0.
  assert (n + (m - n) + q = n + ((m-n) + q)). omega.
  rewrite H1. assert (n + (m - n + q) - n = m - n + q).
  apply minus_plus. rewrite H2.
  assert (n + (m - n) - n = m - n).
  apply minus_plus. rewrite H3. auto.
Qed.
Hint Resolve minus_plus_commut.

Lemma sp_P2_N2:
forall sp, sp + 2 - 2 = sp.
Proof.
  intro.
  assert (sp + 2 = 2 + sp). auto with arith.
  rewrite H. auto with arith.
Qed.
Hint Resolve sp_P2_N2.

Lemma sp_P4_N2:
forall sp, sp + 4 - 2 = sp + 2.
Proof.
  intro sp.
  omega.
Qed.
Hint Resolve sp_P4_N2.

Lemma sp_P2_P2:
forall sp, sp + 2 + 2 = sp + 4.
Proof.
  intro sp. omega.
Qed.
Hint Resolve sp_P2_P2.

Lemma sp_P4_N2_N2:
forall sp, sp + 4 - 2 - 2 = sp.
Proof.
  intro sp. omega.
Qed.
Hint Resolve sp_P4_N2_N2.


Lemma ge_trans:
  forall a b c, a >= b -> b >= c -> a >= c.
Proof.
  intros.
  assert (c <= a).
  apply le_trans with b; auto with arith.
  auto with arith.
Qed.


Lemma sp_P4_P2:
forall sp, sp + 4 + 2 = sp + 6.
Proof.
  intro. omega.
Qed.
Hint Resolve sp_P4_P2.

Lemma sp_P4_N6:
forall sp, sp + 4 - 6 = sp - 2.
Proof.
  intro sp.
  omega.
Qed.
Hint Resolve sp_P4_N6.

Lemma sp_P6_N2:
forall sp, sp + 6 - 2 = sp + 4.
Proof.
  intro sp. omega.
Qed.
Hint Resolve sp_P6_N2.

Lemma sp_N2_P2:
forall sp, sp >= 2 -> sp - 2 + 2 = sp.
Proof.
  intros.
  assert (sp - 2 + 2 = sp + 2 - 2). auto.
  rewrite H0. auto.
Qed.
Hint Resolve sp_N2_P2.

Lemma sp_N2_P4:
forall sp, sp >= 2 -> sp - 2 + 4 = sp + 2.
Proof.
  intros.
  assert (sp - 2 + 4 = sp + 4 - 2). auto.
  assert (sp +  4 - 2 = sp + 2); auto.
  rewrite H1 in H0. rewrite H0. auto.
Qed.
Hint Resolve sp_N2_P4.

Lemma sp_N2_P6:
forall sp, sp >= 2 -> sp - 2 + 6 = sp + 4.
Proof.
  intros.
  assert (sp - 2 + 6 = sp + 6 - 2).
  auto. rewrite H0.
  omega.
Qed.
Hint Resolve sp_N2_P6.

Lemma sp_P2_P1:
forall sp, 
    sp + 2 + 1 = sp + 3.
Proof.
  intro sp. omega.
Qed.
Hint Resolve sp_P2_P1.

