Require Import Coqlib.
Require Import Map.
Require Import Arith.
Require Import Machine.
Require Import Assertion.
Require Import Assertion_Lemmas4.
Require Import Assertion_Lemmas3.
Set Implicit Arguments.
Unset Strict Implicit.

Lemma ptoxW_indom:
  forall l h,
  ptoxW l h
  -> MemMod.in_dom l h /\ MemMod.in_dom (l+1) h.
Proof.
intros.
assert (exists x, h ||- (ptoW l x)).
eapply ptoxW_ptoW. apply H.
destruct H0.
eapply ptoW_indom.
unfold mjudge in H0.
apply H0.
Qed.

(*
Lemma leadsToxW_indom : forall M l ,leadsToxW l M 
  -> (MemMod.in_dom l M /\ MemMod.in_dom (l + 1) M).
(** added by wang **)
Proof.
intros.
destruct H as [M1 [M2 [Mdis [MH MH1]]]].
assert (MemMod.in_dom l M1 /\ MemMod.in_dom (l + 1) M1).
eapply ptoxW_indom. apply MH.
elim H.
intros.
destruct H0.
destruct H1.
split.
eapply indom_disjUnion_indom_l.
exists x. apply H0. apply Mdis.
eapply indom_disjUnion_indom_l.
exists x0. apply H1. apply Mdis.
Qed.

*)
(*
Lemma sub_pto_leadsToW:
  forall l m h1 h,
  ptoW l m h1
  -> MemMod.subseteq h1 h
  -> leadsToW l m h.
Proof.
intros.
substH H with (ptoW_leadsToW H).
assert (H1 := leadsToW_elim H).
substH H with (leadsToW_elim1 H).
unfold MemMod.subseteq in H0.
destruct H.
unfold MemMod.in_dom in H0.
assert (h l = Some m).
rewrite <- H1.
symmetry;apply H0;exists m;assumption.
assert (h (l+1) = Some x ).
rewrite <- H.
symmetry;apply H0;exists x;assumption.
apply leadsToW_intro with x;assumption.
Qed.


Lemma sub_pto_leadsToxW:
  forall l m h1 h,
  ptoW l m h1
  -> MemMod.subseteq h1 h
  -> leadsToxW l h.
Proof.
intros l m h1 h pW subh.
assert (MemMod.disjUnion h1 (MemMod.minus h h1) h).
apply MemMod.minus_disjUnion; auto.
unfold ptoW in pW.
destruct pW as [M1 [M2 [djh  [mM1 mM2]]]].
unfold leadsToxW.
unfold imprecM, ptoxW.
exists h1. exists (MemMod.minus h h1).
unfold mTrue.
split_l.
split_r.
exists M1. exists M2.
split_l.
split_r.
unfold ptox.
exists m; auto.
Qed.

Lemma ptox_ptoW:
  forall l h,
  ptoxW l h
  -> exists m, ptoW l m h.
Proof.
intros.
destruct H as [M1 [M2 [Mdis [MH MH2]]]].
destruct MH.
exists x.
exists M1. exists M2. auto.
Qed.
*)
Lemma ptoxW_MemUpd16_MonoL : forall l x M1 M2 M M',
  MemMod.disjUnion M1 M2 M
  -> ptoxW l M1
  -> MemUpd16 M l x M'
  -> exists M1', MemMod.disjUnion M1' M2 M'
    /\ MemUpd16 M1 l x M1'.
Proof.
  unfold MemUpd16.
  intros l x M1 M2 M M' djM ldxW mup.
  destruct mup as [x0 mup].   rewrite mup.
  exists (MemMod.put (MemMod.put M1 l x) (l + 1) x0).
  destruct (ptoxW_indom ldxW).
  split.
    apply MemMod.update_presv_disjUnion_left.
    apply MemMod.update_presv_disjUnion_left; auto.
    assert (MemMod.sub_dom M1 (MemMod.put M1 l x)).
    apply MemMod.subDom_update; auto.
    apply H1; auto.
  exists x0; auto.
Qed.

Lemma ptoxW_MemUpd16_MonoR : forall l x M1 M2 M M',
  MemMod.disjUnion M1 M2 M
  -> ptoxW l M2
  -> MemUpd16 M l x M'
  -> exists M2', MemMod.disjUnion M1 M2' M'
    /\ MemUpd16 M2 l x M2'.
Proof.
  unfold MemUpd16.
  intros l x M1 M2 M M' djM ldxW mup.
  destruct mup as [x0 mup].   rewrite mup.
  exists (MemMod.put (MemMod.put M2 l x) (l + 1) x0).
  destruct (ptoxW_indom ldxW).
  split.
    apply MemMod.update_presv_disjUnion_right.
    apply MemMod.update_presv_disjUnion_right; auto.
    assert (MemMod.sub_dom M2 (MemMod.put M2 l x)).
    apply MemMod.subDom_update; auto.
    apply H1; auto.
  exists x0; auto.
Qed.

Implicit Arguments ptoxW_MemUpd16_MonoL [l x M1 M2 M M'].
Implicit Arguments ptoxW_MemUpd16_MonoR [l x M1 M2 M M'].

(* requisite *)
Lemma leadsToW_leadsToBlk:
  forall ax x h,  (ax  |~>w x) h ->  leadsToBlk ax 2 h.
Proof.
intros.
destruct H as [M1 [M2 [Mdis [MH MH1]]]].
exists M1.
exists M2.
split. auto.
split.
destruct MH as [M3 [M4 [Mdis1 [MH2 MH3]]]].
exists M3. exists M4.
split. apply Mdis1.
split. exists x.
auto.
exists M4. exists MemMod.emp.
split.
apply MemMod.unit_emp_disjUnion.
split. auto.
unfold ptoxBlk.
unfold Aemp.
reflexivity.
auto.
Qed.

Hint Resolve mstar_assoc_left_right mstar_assoc_right_left.
