(* This is the SCAP for non-handler code *)
Add LoadPath "..".

Require Import Coqlib.
Require Import Machine.
Require Import Assertion.

Set Implicit Arguments.
Unset Strict Implicit.

Parameters INV0 INV1 : MPred.

Parameter Prec0 : precise INV0.

Parameter Prec1 : precise INV1.

Lemma Prec01 : precise (mstar INV0 INV1).
Proof.
  apply mstar_presv_prec; [apply Prec0 | apply Prec1].
Qed.

Parameter curr_thrd : Label.

Parameter ready_Q : Label.

(* entry points for primitives *)
Parameters _SWITCH _BLOCK _UNBLK : flab.

(* stack spaces required by these functions *)
(* Parameters _SW_Stk _BLK_Stk _UNBLK_Stk : nat.*)
Notation _SW_Stk := 8 (only parsing).
Notation _BLK_Stk := 10 (only parsing).
Notation _UNBLK_Stk := 10 (only parsing).

Definition prim_entry (f : flab) :=
  (f = _SWITCH) \/ (f = _BLOCK) \/ (f = _UNBLK).

Definition WQassert := MPred.

Definition WQSpec := Label -> optionT WQassert.

Parameter Delta : WQSpec.

Definition disj_PM (p : Pred) (m : MPred) : Prop :=
  exists S, pmstar p m S.

Definition choice (p : Prop) (m m' : MPred) : MPred :=
  fun (M : Mem) => (p /\ m M) \/ (~p /\ m' M).

(* stack space required by interrupt handler *)
(* Notation IH_Stk := (14 + 8 + 2). *)
Notation IH_Stk := (24) (only parsing).

(**  Spec Tag of System Calls **)
Parameter sctag : Label.
