Add LoadPath "..".

Require Import Coqlib.
Require Import Machine.
Require Import Assertion.
Require Import AIM.

Lemma choice_elim_left : forall (P : Prop) (mP mQ : MPred) M,
  (choice P mP mQ) M -> P -> mP M.
Proof.
  unfold choice; intros; intuition.
Qed.
Implicit Arguments choice_elim_left [P mP mQ M].

Lemma choice_elim_right : forall (P : Prop) (mP mQ : MPred) M,
  (choice P mP mQ) M -> ~P -> mQ M.
Proof.
  unfold choice; intros; intuition.
Qed.
Implicit Arguments choice_elim_right [P mP mQ M].

Lemma choice_intro_left : forall (P : Prop) (mP mQ : MPred) M,
  mP M -> P -> (choice P mP mQ) M.
Proof.
  unfold choice; intros; intuition.
Qed.
Implicit Arguments choice_intro_left [P mP mQ M].

Lemma choice_intro_right : forall (P : Prop) (mP mQ : MPred) M,
  mQ M -> ~P -> (choice P mP mQ) M.
Proof.
  unfold choice; intros; intuition.
Qed.
Implicit Arguments choice_intro_right [P mP mQ M].
